=== src/Makefile ===
--- 
+++ 
@@ -34,7 +34,29 @@
 #   (2) To generate function prototypes, you need a program called
 #       xtractprotos.  Build it with this command:
 #          make xtractprotos
-#       Then 'make allprotos'
+#       Then use it with 'make allprotos'
+#
+#   Customization for cygwin:
+#   (1) Remove viewfiles.c from source
+#   (2) Use the appropriate $CC
+#   (3) For the leptprotos target, the executable that has been
+#       built is xtractprotos.exe.  (add the ".exe")
+#
+#   Customization for Microsoft compilers (e.g., VC++6.0):
+#   (1) Substitute arrayaccess.h.ms60 for arrayaccess.h, if necessary
+#   (2) invoke with -DUSE_PSTDINT to use the pstdint.h file (included)
+#
+#   Customization for removing functions that depend on external
+#   libraries (jpeg, png, tiff, gzip), and I/O in general:
+#   (1) Replace selected files in the Makefile, from this set of stubs:
+#        bmpio.c   -->  bmpiostub.c
+#        jpegio.c  -->  jpegiostub.c
+#        pngio.c   -->  pngiostub.c
+#        pnmio.c   -->  pnmiostub.c
+#        psio.c    -->  psiostub.c
+#        tiffio.c  -->  tiffiostub.c
+#        zlibmem.c -->  zlibmemstub.c
+#   (2) Comment out selected I/O header files from alltypes.h
 #
 #   Stuff used by Makefile
 RM =		rm -f
@@ -47,9 +69,6 @@
 # Libraries are built into a binary tree with its root in the parent directory
 ROOT_DIR =	..
 
-# To find prog/xtractprotos.c when building the executable
-VPATH =	.:../prog
-
 BASE_OBJ =	$(ROOT_DIR)/obj
 OBJ_NODEBUG =	$(ROOT_DIR)/obj/nodebug
 OBJ_DEBUG =	$(ROOT_DIR)/obj/debug
@@ -62,7 +81,7 @@
 
 
 # Include files
-INCLUDES =	-I./ -I/usr/X11R6/include $(EXTRAINCLUDES)
+INCLUDES =	-I. $(EXTRAINCLUDES)
 PROTOTYPE_DIR =	.
 
 # Conditional compilation (depending on processor endian-ness)
@@ -91,8 +110,9 @@
 #     use -DNO_CONSOLE_IO to remove all L_INFO, L_WARNING and
 #        ERROR_* logging, and to remove all DEBUG information dependent
 #        on whether or not NO_CONSOLE_IO has been defined.
-#     remove -fPIC to avoid warnings on cygwin
+#     use -D_CYGWIN_ENVIRON (and without -fPIC) for cygwin
 CC =		gcc -ansi -Werror -D_BSD_SOURCE -DANSI -fPIC
+#CC =		gcc -ansi -Werror -D_CYGWIN_ENVIRON -DANSI
 #CC =		gcc -ansi -Werror -DNO_CONSOLE_IO -D_BSD_SOURCE -DANSI -fPIC
 #CC =		g++ -Werror -D_BSD_SOURCE -fPIC
 #CC =		g++ -Wunused -D_BSD_SOURCE -fPIC
@@ -110,19 +130,16 @@
 # Links are created among the files <libname>.X.Y,
 # <libname>.X, and <libname>, where Y is the minor revision number.
 MAJOR_REV = 1
-MINOR_REV = 37
+MINOR_REV = 45
 
 #########################################################
 
 # Libraries
 
 LEPTLIB =		liblept.a
-
 LEPTLIB_SHARED =	liblept.so
 
 #########################################################
-
-# Source:   (on cygwin, comment out viewfiles.c)
 
 LEPTLIB_C =	adaptmap.c \
 		affine.c \
@@ -134,27 +151,29 @@
 		binexpand.c binexpandlow.c \
 		binreduce.c binreducelow.c \
 		blend.c bmf.c bmpio.c \
-		box.c \
-		ccbord.c \
-		colormap.c colorquant.c colorseg.c \
-		conncomp.c \
+		boxbasic.c boxfunc.c \
+		ccbord.c classapp.c \
+		colorcontent.c colormap.c colormorph.c \
+		colorquant.c colorseg.c \
+		compare.c conncomp.c \
 		convolve.c convolvelow.c \
 		enhance.c \
 		fhmtauto.c \
 		fhmtgen.1.c fhmtgenlow.1.c \
-		fmorph.c \
+		flipdetect.c fliphmtgen.c \
 		fmorphauto.c \
 		fmorphgen.1.c fmorphgenlow.1.c \
-		fmorphlow.c \
 		gplot.c graphics.c \
 		graymorph.c graymorphlow.c \
 		grayquant.c grayquantlow.c \
 		jbclass.c jpegio.c \
 		list.c maze.c \
-		morph.c morphapp.c morphseq.c \
-		numarray.c paintcmap.c \
+		morph.c morphapp.c morphdwa.c morphseq.c \
+		numabasic.c numafunc.c \
+		pageseg.c paintcmap.c \
 		parseprotos.c pheap.c \
-		pix1.c pix2.c pixa.c pixarith.c pixconv.c \
+		pix1.c pix2.c pix3.c pixa.c \
+		pixacc.c pixarith.c pixconv.c \
 		pngio.c pnmio.c pqueue.c \
 		projective.c psio.c \
 		pts.c \
@@ -171,9 +190,7 @@
 		shear.c skew.c stack.c \
 		textops.c tiffio.c utils.c \
 		viewfiles.c \
-		writefile.c
-
-SRC =		$(LEPTLIB_C)
+		writefile.c zlibmem.c
 
 LEPTLIB_H =	allheaders.h alltypes.h \
 		array.h arrayaccess.h bbuffer.h \
@@ -212,22 +229,26 @@
 #  when you 'make allprotos'.  Before making allprotos the first
 #  time, 'make xtractprotos'  (Also, see the comments near the top
 #  of this Makefile.)
+#
+#  Note for cygwin: change the leptprotos target to:
+#     - test for xtractprotos.exe 
+#     - run ./xtractprotos.exe ...
 
 allprotos:	leptprotos
 
 leptprotos:	$(LEPTLIB_C)
-		[ -f xtractprotos ] || echo "Please run 'make xtractprotos'"
+		@$(TEST) -f xtractprotos || echo "First run 'make xtractprotos'"
 		./xtractprotos $(LEPTLIB_C) > tempprotos.h
 		mv tempprotos.h $(PROTOTYPE_DIR)/$@.h
 
 ##################################################################
 
 #  xtractprotos
-
+#
 xtractprotos:	leptlib xtractprotos.o
 	$(CC) -o xtractprotos xtractprotos.o $(LIB_NODEBUG)/liblept.a
 
-xtractprotos.o:	../prog/xtractprotos.c
+xtractprotos.o:	xtractprotos.c
 
 ##################################################################
 
@@ -324,17 +345,13 @@
 			$(OBJ_SHARED)/*.o \
 			$(LIB_NODEBUG)/*.a $(LIB_DEBUG)/*.a \
 			$(LIB_SHARED)/*.so $(LIB_SHARED)/*.so.? \
-			$(LIB_SHARED)/*.so.?.? \
+			$(LIB_SHARED)/*.so.?.* \
 			xtractprotos.o xtractprotos
 
 ###########################################################
 
 depend:
-	/usr/X11R6/bin/makedepend -DNO_PROTOS $(CPPFLAGS) $(SRC)
+	/usr/bin/makedepend -DNO_PROTOS $(CPPFLAGS) $(LEPTLIB_C)
 
 ###########################################################
 # DO NOT DELETE THIS LINE -- make depend depends on it.
-
-
-
-
