=== debian/changelog ===
leptonlib (1.45-2) unstable; urgency=low

  * Add sample images

 -- Jeff Breidenbach <jab@debian.org>  Fri,  1 Jun 2007 15:56:49 -0700

leptonlib (1.45-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Fri,  1 Jun 2007 13:59:43 -0700

leptonlib (1.43-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Tue,  3 Apr 2007 14:31:18 -0700

leptonlib (1.42-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Tue, 23 Jan 2007 15:52:37 -0800

leptonlib (1.37-1) unstable; urgency=low

  * New upstream release

 -- Jeff Breidenbach <jab@debian.org>  Thu, 13 Jul 2006 11:24:50 -0700

leptonlib (1.36-1) unstable; urgency=low

  * Initial Release.

 -- Jeff Breidenbach <jab@debian.org>  Tue, 27 Jun 2006 14:50:37 -0700
